//
// nono
// Copyright (C) 2020 nono project
// Licensed under nono-license.txt
//

#pragma once

#include "netdriver.h"

class NetDriverBPF : public NetDriver
{
	using inherited = NetDriver;
 public:
	// コンストラクタ
	NetDriverBPF(EthernetDevice *parent_, std::mutex *mtx_,
		std::condition_variable *cv_);
	// デストラクタ
	~NetDriverBPF() override;

	bool Init() override;
	bool SendPacket(const std::vector<uint8>& data) override;
	void ThreadRun() override;

 private:
	void Close();

	std::string FindInterface();

	std::unique_ptr<char[]> bpfbuf {};
	int bpfbuflen = 0;
};
