//
// nono
// Copyright (C) 2020 nono project
// Licensed under nono-license.txt
//

#pragma once

#include "device.h"

class IOCtlrDevice
	: public IODevice
{
	using inherited = IODevice;
 private:
	static const int baseaddr = 0xe9c000;

 public:
	IOCtlrDevice();
	~IOCtlrDevice() override;

	void IntFDC();

 protected:
	// BusIO インタフェース
	static const uint32 NPORT = 8;
	uint64 Read(uint32 addr);
	uint64 Write(uint32 addr, uint32 data);
	uint64 Peek(uint32 addr);

 private:
	bool hdd_int = false;
	bool fdc_int = false;
	bool fdd_int = false;
	bool prt_int = false;
	bool hdd_en = false;
	bool fdc_en = false;
	bool fdd_en = false;
	bool prt_en = false;
	uint8 vector = 0;
};

extern std::unique_ptr<IOCtlrDevice> gIOCtlr;
