//
// nono
// Copyright (C) 2020 nono project
// Licensed under nono-license.txt
//

#pragma once

#include "device.h"
#include <sys/time.h>

class PlutoDevice
	: public IODevice
{
	using inherited = IODevice;
 public:
	PlutoDevice();
	~PlutoDevice() override;

	uint64 Read8(uint32 addr) override;
	uint64 Read16(uint32 addr) override;
	uint64 Read32(uint32 addr) override;
	uint64 Write8(uint32 addr, uint32 data) override;
	uint64 Write16(uint32 addr, uint32 data) override;
	uint64 Peek8(uint32 addr) override;

 private:
	// ROM
	static const uint16 rom[];

	// ホストファイル起動
	uint32 ROM_Load();

	// ベンチマーク
	void write_8_benchmark(uint32 addr, uint32 data);
	void benchmark_start(uint32 data);
	void benchmark_end();
	int m_count = 0;
	int m_test_num = 0;
	const char *m_test_name = NULL;
	int m_inst_len = 0;
	int m_inst_cycle = 0;
	int m_start_addr = 0;
	timeval m_start {};
	timeval m_total {};
};
