//
// nono
// Copyright (C) 2020 nono project
// Licensed under nono-license.txt
//

#include "printer.h"

PrinterDevice::PrinterDevice()
{
	logname = "printer";
	devname = "Printer";
	devaddr = baseaddr;
	devlen  = 0x2000;
}

PrinterDevice::~PrinterDevice()
{
}

uint64
PrinterDevice::Read8(uint32 addr)
{
	// 書き込み専用
	return (uint64)-1;
}

uint64
PrinterDevice::Read16(uint32 addr)
{
	// 書き込み専用
	return (uint64)-1;
}

uint64
PrinterDevice::Write8(uint32 addr, uint32 data)
{
	uint32 offset = addr - baseaddr;
	switch (offset) {
	 case 0:
		putlog(0, "未実装データ書き込み");
		break;
	 case 3:
		putlog(0, "未実装ストローブ書き込み");
		return 0;
	 default:
		break;
	}
	return (uint64)-1;
}

uint64
PrinterDevice::Write16(uint32 addr, uint32 data)
{
	return Write8(addr + 1, data);
}

uint64
PrinterDevice::Peek8(uint32 addr)
{
	// XXX
	return 0xff;
}
