//
// nono
// Copyright (C) 2020 nono project
// Licensed under nono-license.txt
//

#pragma once

#include "ethernet.h"
#include "rom.h"

class PROMDevice
	: public ROMDevice
{
	using inherited = ROMDevice;
 public:
	PROMDevice();
	~PROMDevice() override;

	bool Init() override;
	bool PowerOn() override;

	uint64 Read8(uint32 addr) override;
	uint64 Write8(uint32 addr, uint32 data) override;
	uint64 Write32(uint32 addr, uint32 data) override;

 private:
	bool InitLuna();
	bool InitLuna88k();

	uint64 start_time = 0;				// パフォーマンス測定用
};

extern std::unique_ptr<PROMDevice> gPROM;
