//
// nono
// Copyright (C) 2020 nono project
// Licensed under nono-license.txt
//

#pragma once

#include "device.h"
#include "upd7201.h"

class SCCDevice
	: public uPD7201Device
{
	using inherited = uPD7201Device;
 private:
	static const int baseaddr = 0xe98000;

 public:
	SCCDevice();
	~SCCDevice() override;

	void ResetHard() override;

	// XXX 親の同名メソッドと名前分けたほうがいいか
	uint8 ReadCtrl(struct SIO::channel *chan) override;
	void WriteCtrl(struct SIO::channel *chan, uint32 data) override;

	void Interrupt() override;

 protected:
	// BusIO インタフェース
	static const uint32 NPORT = 4;
	uint64 Read(uint32 addr);
	uint64 Write(uint32 addr, uint32 data);
	uint64 Peek(uint32 addr);
};

extern std::unique_ptr<SCCDevice> gSCC;
