//
// nono
// Copyright (C) 2020 nono project
// Licensed under nono-license.txt
//
// SCSI
//

#include "scsibus.h"

// cmd に対応するコマンド名を返す。
const char *
SCSI::GetCommandName(uint8 cmd)
{
	if (cmd < countof(commandname)) {
		return commandname[cmd];
	} else {
		return NULL;
	}
}

// コマンド名
/*static*/ const char * const
SCSI::commandname[Command::MAX] =
{
	"TestUnitReady",		// 00
	"RezeroUnit",			// 01
	NULL,					// 02
	"RequestSense",			// 03
	"FormatUnit",			// 04
	NULL,					// 05
	NULL,					// 06
	"ReassignBlocks",		// 07
	"Read(6)",				// 08
	NULL,					// 09
	"Write(6)",				// 0a
	"Seek(6)",				// 0b
	NULL,					// 0c
	NULL,					// 0d
	NULL,					// 0e
	NULL,					// 0f

	NULL,					// 10
	NULL,					// 11
	"Inquiry",				// 12
	NULL,					// 13
	NULL,					// 14
	"ModeSelect(6)",		// 15
	"Reserve",				// 16
	"Release",				// 17
	"Copy",					// 18
	NULL,					// 19
	"ModeSense(6)",			// 1a
	"StartStopUnit",		// 1b
	"ReceiveDiagnosticResults",		// 1c
	"SendDiagnostic",		// 1d
	"PreventAllowMediumRemoval",	// 1e
	NULL,					// 1f

	NULL,					// 20
	NULL,					// 21
	NULL,					// 22
	NULL,					// 23
	NULL,					// 24
	"ReadCapacity",			// 25
	NULL,					// 26
	NULL,					// 27
	"Read(10)",				// 28
	NULL,					// 29
	"Write(10)",			// 2a
	"Seek(10)",				// 2b
	NULL,					// 2c
	NULL,					// 2d
	"WriteAndVerify(10)",	// 2e
	"Verify(10)",			// 2f

	"SearchDataHigh(10)",	// 30
	"SearchDataEqual(10)",	// 31
	"SearchDataLow(10)",	// 32
	"SetLimits",			// 33
	"PreFetch",				// 34
	"SynchronizeCache",		// 35
	"LockUnlockCache",		// 36
	"ReadDefectData(10)",	// 37
	NULL,					// 38
	"Compare",				// 39
	"CopyAndVerify",		// 3a
	"WriteBuffer",			// 3b
	"ReadBuffer",			// 3c
	NULL,					// 3d
	"ReadLong",				// 3e
	"WriteLong",			// 3f

	"ChangeDefinition",		// 40
	"WriteSame",			// 41
	NULL,					// 42
	NULL,					// 43
	NULL,					// 44
	NULL,					// 45
	NULL,					// 46
	NULL,					// 47
	NULL,					// 48
	NULL,					// 49
	NULL,					// 4a
	NULL,					// 4b
	"LogSelect",			// 4c
	"LogSense",				// 4d
	NULL,					// 4e
	NULL,					// 4f
	NULL,					// 50
	NULL,					// 51
	NULL,					// 52
	NULL,					// 53
	NULL,					// 54
	"ModeSelect(10)",		// 55
	NULL,					// 56
	NULL,					// 57
	NULL,					// 58
	NULL,					// 59
	"ModeSense(10)",		// 5a
};
