//
// nono
// Copyright (C) 2020 nono project
// Licensed under nono-license.txt
//

#pragma once

#include "device.h"
#include "scheduler.h"

class SysClkDevice
	: public IODevice
{
	using inherited = IODevice;
 public:
	SysClkDevice();
	~SysClkDevice() override;

	bool Init() override;
	bool PowerOn() override;

 protected:
	// BusIO インタフェース
	static const uint32 NPORT = 1;
	uint64 Read(uint32);
	uint64 Write(uint32, uint32);
	uint64 Peek(uint32);

 private:
	// イベントコールバック
	void Callback(int);

	// 割り込み状態をレジスタイメージにして返す
	uint8 GetInt() const;

	// システムクロック割り込み有りなら true。
	bool sysint = false;

	// 割り込みイベント
	Event event {};
};
