//
// nono
// Copyright (C) 2020 nono project
// Licensed under nono-license.txt
//

// LUNA88K のシステムコントローラのような何か

#pragma once

#include "device.h"

class SysCtlrDevice
	: public IODevice
{
	using inherited = IODevice;
 public:
	SysCtlrDevice();
	~SysCtlrDevice() override;

	void MonitorUpdate(TextScreen&) override;

	uint64 Read32(uint32 addr) override;
	uint64 Write32(uint32 addr, uint32 data) override;
	uint64 Peek8(uint32 addr) override;

	uint8 GetIntMask(int id) const { return intmask[id]; }
	void  TellIntLevel(int id, int level) { intlevel[id] |= level; }
 private:
	uint8 intmask[4] {};
	// 発生した割り込みのレベルビットマップ
	uint8 intlevel[4] {};
};

extern std::unique_ptr<SysCtlrDevice> gSysCtlr;
