//
// nono
// Copyright (C) 2020 nono project
// Licensed under nono-license.txt
//

#pragma once

#include "vm.h"

class VM_LUNA : public VM
{
	using inherited = VM;
 public:
	VM_LUNA();
	~VM_LUNA() override;

	// 電源ボタンを押す。
	void PowerButton() override;

 private:
	std::unique_ptr<CRTC2Device> crtc2;
	std::unique_ptr<IODevice> prom;
	std::unique_ptr<SysClkDevice> sysclk;
	std::unique_ptr<NullDevice> nulldev;

	static const uint8 maptable[256];
};

class VM_LUNA88K : public VM
{
	using inherited = VM;
 public:
	VM_LUNA88K();
	~VM_LUNA88K() override;

	// 電源ボタンを押す。
	void PowerButton() override;

 private:
	std::unique_ptr<CRTC2Device> crtc2;
	std::unique_ptr<FuseROMDevice> fuserom;
	std::unique_ptr<IODevice> prom;
	std::unique_ptr<SysClkDevice> sysclk;
	std::unique_ptr<NullDevice> nulldev;

	static const uint8 maptable[256];
};
