//
// nono
// Copyright (C) 2020 nono project
// Licensed under nono-license.txt
//

#pragma once

#include "vm.h"

class VM_X68030 : public VM
{
	using inherited = VM;
 public:
	VM_X68030();
	~VM_X68030() override;

	// 電源ボタンを押す
	void PowerButton() override;

	// 電源ボタンの状態を取得。オンなら true。
	bool IsPowerButton() const override { return power_button; }

 private:
	// 電源ボタンの状態。オンなら true。
	bool power_button = false;

	// デバイス
	std::unique_ptr<XIOSpaceDevice> xiospace;
};

class VM_RXZ : public VM
{
	using inherited = VM;
 public:
	VM_RXZ();
	~VM_RXZ() override;

	// 電源ボタンを押す。
	void PowerButton() override;

 private:
	std::unique_ptr<Human68k> human68k;
};
