//
// nono
// Copyright (C) 2020 nono project
// Licensed under nono-license.txt
//

#pragma once

#include "header.h"
#include "object.h"

// wx のシステムヘッダ内で警告出られてもどうしようもないのでワーニング抑制
#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Weverything"
#else
#pragma GCC   diagnostic push
#pragma GCC   diagnostic ignored "-Wcast-qual"
#pragma GCC   diagnostic ignored "-Wignored-qualifiers"
#endif

#include <wx/wxprec.h>
#ifndef WX_PRECOMP
#include <wx/wx.h>
#endif

// ワーニング抑制ここまで
#if defined(__clang__)
#pragma clang diagnostic pop
#else
#pragma GCC   diagnostic pop
#endif

// 独自のイベントタイプ
wxDECLARE_EVENT(WXW_EVT_CREATE, wxCommandEvent);
wxDECLARE_EVENT(WXW_EVT_HALT_NOTIFY, wxCommandEvent);

// OnCreate イベントがあるかのように扱う
// イベント登録
#define EVT_CREATE(func)	EVT_COMMAND(wxID_ANY, WXW_EVT_CREATE, func)
// OnCreate イベントを使う場合コンストラクタでコールしておく
#define POST_CREATE()	do {	\
	wxCommandEvent *event = new wxCommandEvent(WXW_EVT_CREATE);	\
	QueueEvent(event);	\
} while (0)

// フォント種別というかフォントサイズ。
// 配列のインデックスとして使うので有効な値を 0 から列挙する。
enum FontId {
	None = -1,
	_6x12 = 0,
	_8x16,
	Max,
};
#define FONT_6x12	wxSize(6, 12)
#define FONT_8x16	wxSize(8, 16)

class WXMainFrame;
class WXMainView;
class WXTextScreen;
