//
// nono
// Copyright (C) 2020 nono project
// Licensed under nono-license.txt
//

#pragma once

#include "wxsubwindow.h"
#include "wxtextscreen.h"

//
// 履歴モニタ (共通部分)
//
class WXHistoryMonitor : public WXVResizeSubWindow
{
	using inherited = WXVResizeSubWindow;
 public:
	WXHistoryMonitor(wxWindow *parent, wxWindowID id,
		const wxString& name, IMonitor& monitor);
	virtual ~WXHistoryMonitor() override;

 protected:
	// 例外履歴かどうかのフラグ
	uint64 exflag {};

 private:
	// ウィンドウサイズ再計算
	void DoSize() override;

	// サイズ変更イベント
	void OnSize(wxSizeEvent& event);

	// マウスホイールイベント
	void OnMouseWheel(wxMouseEvent&);

	// スクロールイベント
	void OnScroll(wxScrollEvent& event);

	// スクロール処理
	void DoScroll(int pos);

	// スクロールバー
	wxScrollBar *vscroll = NULL;

	// イベントテーブル
	wxDECLARE_EVENT_TABLE();
};

//
// ブランチ履歴モニタ
//
class WXBranchHistoryMonitor : public WXHistoryMonitor
{
	using inherited = WXHistoryMonitor;
 public:
	WXBranchHistoryMonitor(wxWindow *parent, wxWindowID id,
		IMonitor& monitor);
	virtual ~WXBranchHistoryMonitor();
};

//
// 例外履歴モニタ
//
class WXExceptionHistoryMonitor : public WXHistoryMonitor
{
	using inherited = WXHistoryMonitor;
 public:
	WXExceptionHistoryMonitor(wxWindow *parent, wxWindowID id,
		IMonitor& monitor);
	virtual ~WXExceptionHistoryMonitor();
};
