//
// nono
// Copyright (C) 2020 nono project
// Licensed under nono-license.txt
//

//
// LUNA LCD パネル
//

#pragma once

#include "wxheader.h"
#include "wxsubwindow.h"

// LCD パネル
class WXLCDPanel : public wxPanel
{
	using inherited = wxPanel;
 public:
	WXLCDPanel(wxWindow *parent);
	~WXLCDPanel();

 private:
	void OnTimer(wxTimerEvent& event);
	void OnPaint(wxPaintEvent& event);
	void Draw(wxDC&);
	void DrawChar(wxDC&, int x, int y, uint8 ch);

	const uint8 *ddram {};

	std::unique_ptr<uint8[]> bmpbuf {};
	std::unique_ptr<wxImage> image {};
	std::unique_ptr<wxBitmap> bitmap {};

	// 描画管理用
	uint32 count {};
	wxTimer timer {};

	wxDECLARE_EVENT_TABLE();
};

// LCD ウィンドウ
class WXLCDWindow : public WXSubWindow
{
	using inherited = WXSubWindow;
 public:
	WXLCDWindow(wxWindow *parent, wxWindowID id);
	~WXLCDWindow();

 private:
	WXLCDPanel *panel {};
};

// LCD キャラクタパネル
class WXLCDCharPanel : public wxPanel
{
	using inherited = wxPanel;
 public:
	WXLCDCharPanel(wxWindow *parent);
	~WXLCDCharPanel();

 private:
	void OnPaint(wxPaintEvent& event);
	void Draw(wxDC&);

	std::unique_ptr<uint8[]> bmpbuf {};
	std::unique_ptr<wxImage> image {};
	std::unique_ptr<wxBitmap> bitmap {};

	wxDECLARE_EVENT_TABLE();
};

// LCD キャラクタウィンドウ
class WXLCDMonitor : public WXSubWindow
{
	using inherited = WXSubWindow;
 public:
	WXLCDMonitor(wxWindow *parent, wxWindowID id);
	~WXLCDMonitor();

 private:
	WXTextScreen *monpanel {};
	WXLCDCharPanel *chrpanel {};
};
