//
// nono
// Copyright (C) 2020 nono project
// Licensed under nono-license.txt
//

#include "wxmonitor.h"
#include "wxtextscreen.h"

//
// モニターウィンドウ
//

// コンストラクタ
WXMonitorWindow::WXMonitorWindow(wxWindow *parent, wxWindowID id,
	const wxString& name, IMonitor& monitor_)
	: inherited(parent, id, name)
{
	// ↓+------------------+
	//   |     上余白       |
	//   |左+------------+右|
	//   |余| TextScreen |余|
	//   |白+------------+白|
	//   |     下余白       |
	//   +------------------+

	wxBoxSizer *topsizer = new wxBoxSizer(wxVERTICAL);

	// テキストスクリーン
	screen = new WXTextScreen(this, monitor_);
	topsizer->Add(screen, 0, wxEXPAND | wxALL, DefaultPadding);

	SetSizer(topsizer);

	// 大きさをそれに固定
	Layout();
	Fit();
}

// デストラクタ
WXMonitorWindow::~WXMonitorWindow()
{
}
