//
// nono
// Copyright (C) 2020 nono project
// Licensed under nono-license.txt
//

#pragma once

#include "wxsubwindow.h"
#include "wxtextscreen.h"

class m88200;
class WXCacheWindow;

//
// CMMU キャッシュウィンドウ用のパネル
//
class WXCacheTextScreen : public WXTextScreen
{
	using inherited = WXTextScreen;
 public:
	WXCacheTextScreen(wxWindow *, IMonitor&);
	virtual ~WXCacheTextScreen();

 private:
	// マウスイベント
	void OnLeftDown(wxMouseEvent& event);

	// 親クラス
	WXCacheWindow *parentwindow;

	// イベントテーブル
	wxDECLARE_EVENT_TABLE();
};

//
// CMMU キャッシュウィンドウ
//
class WXCacheWindow : public WXSubWindow, public IMonitor
{
	using inherited = WXSubWindow;
 public:
	WXCacheWindow(wxWindow *, wxWindowID, const wxString& name, m88200 *cmmu);
	virtual ~WXCacheWindow() override;

	// 右クリック処理
	void DoLeftDown(int x, int y);

	nnSize GetMonitorSize() override;
	void MonitorUpdate(TextScreen& ts) override;

 private:
	// テキストスクリーンコントロール
	WXCacheTextScreen *screen = NULL;

	// 現在表示中のセット
	uint setidx {};

	// CMMU
	m88200 *cmmu {};
};
